unit unit1;

interface            

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;   
    Label2: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Image: TImage;
    Tampon: TImage;
    Label3: TLabel;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

station = record
          nom:string;
          x:integer;
          y:integer;
          end;

arc = record
      depart,arrivee : integer ;
      ligne          : string ;
      parcouru       : boolean ;
      end ;

tp = array[1..20] of integer ;  //--- nombre max de stations voisines d'une station donne
                                //au pif 20

// toute station d'une ligne non situe en bout de ligne a deux voisines, une  gauche
// et une  droite. Les bouts de ligne ont une seule voisine.


var
  Form1        : TForm1;
  Arcs         : array[0..800] of arc ;  // tableau des arcs
  t_partantes  : array[0..800] of  // tableau des stations partantes pour chaque
                    record         // station du mtro
                    occupee : boolean ;
                    nb      : integer ;
                    tpa     : tp ;  // max 20 stations partantes d'une station donne
                    end ;
  min_stations : integer ;
  chemin       : string; {AVEC l'antislash final}
  Stations     : array[0..314] of station ; {stations : nom et coordonnes}
  tab_arcs     : array[0..800] of integer ;
  nb_arcs      : integer ;
  max_chgt     : integer ;
  nb_lignes    : integer;   {nb de lignes -1}
  nb_stations  : integer; {nb de stations -1}

  //--- variables utilises pour l'affichage du plan du mtro
  li:array[0..30,0..100] of integer; //les lignes avec leurs stations dans l'ordre
                                     //l'lment li[i,0] contient le nb de stattions de la ligne
  n_li         : array[0..30] of string; {noms des lignes}
  first        : boolean;
  x_min,x_max  : integer ;//pour cadrage plan
  y_min,y_max  : integer; //pour cadrage plan
  ox,oy,ow,oh  : integer; {coordonnes du rectangle  effacer pour les bulles d'aide
                          montrant les noms des stations}
  

implementation

{$R *.DFM}

procedure dessine(iti:boolean); forward;

procedure init_arcs ;
var i,j         : integer;
    F           : TextFile;
    d,d1,fic    : string; {d=dummy}
    x,n         : integer;
begin
     fic:=chemin+'paris.dat';
     if not FileExists(fic) then
        begin
        MessageDlg(fic+' introuvable.', mtError,[mbOK], 0);
        halt;
        end;
     AssignFile(F,fic);
     Reset(F);
     Readln(F,nb_stations);
     Readln(F,nb_lignes);
     Readln(F,d);
     for i:=0 to nb_stations do
         begin
         Readln(F,d);
         Stations[i].nom:=d ;
         Form1.ComboBox1.Items.Add(d);
         Form1.ComboBox2.Items.Add(d);
         end;
     Form1.ComboBox1.ItemIndex:=0;
     Form1.ComboBox2.ItemIndex:=0;

     nb_arcs:=0 ;
     for i:=0 to nb_lignes do
         begin
         Readln(F,d1);  //"ligne i"
         Readln(F,n);  //nb stations de la ligne
         li[i,0]:=n;
         Readln(F,d);   //nom rel ligne
         n_li[i]:=d;
         for j:=1 to n do
             begin
             Readln(F,x);   //numros des stations
             li[i,j]:=x;
             if j<n then
                begin
                inc(nb_arcs) ;
                Arcs[nb_arcs-1].depart:=x;
                Arcs[nb_arcs-1].ligne:=d;
                if j>1 then
                   begin
                   Arcs[nb_arcs-2].arrivee:=x ;
                   end;
                end
             else
                begin
                Arcs[nb_arcs-1].arrivee:=x ;
                Arcs[nb_arcs-1].ligne:=d ;
                end ;
             end;
         end;

     //arcs rciproques
     j:=nb_Arcs-1;
     for i:=0 to j do
         begin
         inc(nb_arcs) ;
         Arcs[nb_arcs-1].depart:=arcs[i].arrivee ;
         Arcs[nb_arcs-1].arrivee:=arcs[i].depart ;
         Arcs[nb_arcs-1].ligne:=arcs[i].ligne ;
         end;

     //coordonnes
     Readln(F,d);
     for i:=0 to nb_stations do
             begin
             Readln(F,n);
             stations[i].x:=n ;
             Readln(F,n);
             stations[i].y:=n ;
             end;
     CloseFile(F);
end ;

procedure remplir_partantes ;
var i,j : integer ;
begin
for j:=0 to nb_stations do
    begin
    t_partantes[j].nb:=0 ;
    t_partantes[j].occupee:=false ;
    fillchar(t_partantes[j].tpa,sizeof(tp),#0) ;
    for i:=0 to nb_arcs-1 do
        if Arcs[i].depart=j then
           begin
           inc(t_partantes[j].nb) ;
           t_partantes[j].tpa[t_partantes[j].nb]:=i ;
           end ;
    end ;
end ;

procedure marquer_arc(depart,arrivee : integer ;marque : boolean) ;
var i    : integer ;
begin
for i:=0 to nb_Arcs-1 do
    begin
    if (Arcs[i].depart=depart) and (Arcs[i].arrivee=arrivee) then
       Arcs[i].parcouru:=marque ;
    if (Arcs[i].depart=arrivee) and (Arcs[i].arrivee=depart) then
       Arcs[i].parcouru:=marque ;
    end ;
end ;

function trouver(depart,arrivee:integer; nstations,chgt : integer ;prec,liste : string) : boolean ;
var i,p           : integer ;
    la_ligne      : string ;
    s             : string ;
begin
//Optimisation ===========================
if (t_partantes[depart].occupee) or
   (chgt>max_chgt) or
   (nstations>min_stations) then
   begin
   trouver:=false ;
   exit ;
   end ;
//Fin Optimisation ===========================
if depart=arrivee then
   begin
   trouver:=true ;
   if nstations<=min_stations then
      begin
      //si on enlve la ligne suivante, on a tous les chemins
      min_stations:=nstations ;
      Form1.ListBox1.Items.Add(inttostr(nstations)+' stations.') ;
      Form1.ListBox1.ItemIndex:=Form1.ListBox1.Items.Count-1;
      Form1.ListBox1.Refresh;
      form1.ListBox2.Items.add(liste) ;
      Form1.ListBox2.ItemIndex:=Form1.ListBox1.ItemIndex;
      Form1.ListBox2.Refresh;
      {for i:=0 to nstations do
          begin
          form1.listbox1.items.add(Stations[tab_arcs[i]].nom) ;
          end;    }
      Dessine(true);
      Form1.Image.Refresh;
      end ;
   end           
else
   for i:=1 to t_partantes[depart].nb do
       begin
       p:=t_partantes[depart].tpa[i] ;
       if Arcs[p].parcouru=false then   
          begin
          marquer_arc(depart,Arcs[p].arrivee,true) ;
          t_partantes[depart].occupee:=true ;
          tab_arcs[nstations]:=Arcs[p].arrivee ;
          la_ligne:=Arcs[p].ligne ;
          if la_ligne<>prec then inc(chgt) ;
          trouver:=trouver(Arcs[p].arrivee,arrivee,
              nstations+1,chgt,la_ligne,
              liste+','+inttostr(Arcs[p].arrivee)) ;
          if la_ligne<>prec then dec(chgt) ;
          marquer_arc(Arcs[p].arrivee,depart,false) ;
          t_partantes[depart].occupee:=false ;
          end ;
       end;
end ;

procedure Cadrage;
var a,ii,i:integer;

              procedure minmax(i:integer);
              {dtermination des coordonnes x_min, x_max, y_min, y_max pour cadrage}
              var j,a:integer;
              begin
              FOR j:= 1 TO li[i,0] do
                  begin
                  a:= li[i,j];
                  IF Stations[a].x > x_max then x_max:= Stations[a].x;
                  IF Stations[a].y > y_max then y_max:= Stations[a].y;
                  IF Stations[a].x < x_min then x_min:= Stations[a].x;
                  IF Stations[a].y < y_min then y_min:= Stations[a].y;
                  end;
              end;

begin
               a:= 20;
               x_max:= -1;
               x_min:= 999;
               y_max:= -1;
               y_min:= 999;
               FOR ii:= 1 TO a do
                   begin
                        case ii of
                             1..7: i:= ii - 1;
                             8:  {7}
                                 begin
                                 i:= 7;
                                 minmax(i);
                                 i:= 8;
                                 end;
                             9:  {7b}
                                 begin
                                 i:= 9;
                                 minmax(i);
                                 i:= 10;
                                 end;
                             10..11:   {8,9}
                                 i:= ii + 1;
                             12:     {ligne 10}
                                 begin
                                 i:= 13;
                                 minmax(i);
                                 i:= 14;
                                 end;
                             13..14:     {lignes 11 & 12}
                                 i:= ii + 2;
                             15:      {ligne 13}
                                 begin
                                 i:= 17;      {13}
                                 minmax(i);
                                 i:= 18;      {13b}
                                 end;
                             16..20:    {rer}
                                 i:= ii + 3;
                        end;
                        minmax(i);
                   end;
end;

procedure DessineStation(numero:integer;x,y,w,h:longint; cvs:TCanvas);
var x1,y1,dx,dy:integer;
begin
     dx:= x_max - x_min;
     dy:= y_max - y_min;
     cvs.pen.width:=3;
     cvs.brush.style:=bsSolid;
     cvs.brush.color:=clRed;
     x1:=Stations[numero].x;
     y1:=Stations[numero].y;
     x1:= x+x1* (w - (200 * w) div 640) div dx + (50 * w) div 640 - x_min * (w - (200 * w) div 640) div dx;
     y1:= y+y1* (h - (200 * h) div 400) div dy + (100 * h) div 400 - y_min * (h - (200 * h) div 400) div dy;
     cvs.pen.color:=clBlack;
     cvs.Ellipse(x1-6,y1-6,x1+6,y1+6);
     cvs.pen.width:=1;
     cvs.brush.style:=bsClear;
end;

procedure dessine(iti:boolean);
var tab:array[1..200] of integer; count:integer;

          procedure DecodeListe;
          var i:integer; s,t:string;
          begin
               s:=Form1.ListBox2.Items[Form1.ListBox2.ItemIndex];
               t:='';
               count:=0;
               for i:=1 to length(s) do
                   begin
                   if s[i]<>',' then t:=t+s[i]
                   else
                       begin
                       inc(count);
                       tab[count]:=StrToInt(t);
                       t:='';
                       end;
                   end;
               //la dernire station
               inc(count);
               tab[count]:=StrToInt(t);
          end;

          function couleur(i:integer):TColor;
          begin
               case i of
                    0:result:=clBlack;
                    1:result:=clFuchsia;
                    2:result:=clBlue;
                    3:result:=clLime;
                    4:result:=clFuchsia;
                    5:result:=clPurple;
                    6:result:=clGreen;
                    7:result:=clNavy;
                    8:result:=clSilver;
                    9:result:=clTeal;
                    10:result:=clYellow;
                    11:result:=clGray;
                    12:result:=clMaroon;
                    13:result:=clDkGray;
                    14:result:=clOlive;
                    15:result:=clLtGray;
               end;
          end;

          procedure ligne(i,col:integer;x,y,w,h:longint;cvs:TCanvas; var written:array of boolean);
          var nom,factice:boolean;
              dx,dy,x1,y1:longint;
              nam:string;
              a:integer;
              j,wwt,hht,lx,ly,rer,s_circle,deb:integer;
          begin
               dx:= x_max - x_min;
               dy:= y_max - y_min;
               cvs.pen.width:=1;
               cvs.font.color:=clBlack;
               deb:=0;
               factice:=false;
               lx:=0;
               ly:=0;
               cvs.Font.Name:='Times New Roman';
               cvs.Font.Size:=8;
               nom:= false;   {doit-on afficher les noms de stations ?}
               IF (i = 10) OR (i = 14) OR (i = 18) OR (i = 8) then factice:=true;
               rer:= pos('RER',n_li[i]);
               IF factice = false then cvs.pen.color:=couleur(col);
               case i of
                    7..8: nam:= ' 7 ';
                    9..10: nam:= ' 7b ';
                    18: nam:= ' 13 ';
                    19: nam:= ' A ';
                    20: nam:= ' B ';
                    21: nam:= ' C1 C3 ';
                    22: nam:= ' C2 C4 C6 ';
                    23: nam:= ' C5 C7 ';
               else
                   nam:= ' '+n_li[i]+' ';
               end;

               deb:=0;
               FOR j:= 1 TO li[i,0] do begin
                   a:= li[i,j];
                   x1:= x+Stations[a].x * (w - (200 * w) div 640) div dx + (50 * w) div 640 - x_min * (w - (200 * w) div 640) div dx;
                   y1:= y+Stations[a].y * (h - (200 * h) div 400) div dy + (100 * h) div 400 - y_min * (h - (200 * h) div 400) div dy;
                   IF rer<>0 then s_circle:= 3 ELSE s_circle:= 2;

                   IF (j<>1) AND (j<>li[i,0]) OR ((factice=true) AND ((((i=8) AND (j<>li[i,0]))
                   OR ((i=18) AND (j<>li[i,0])) OR ((i=10) AND (j<>1)) OR (i=14)))) then
                      begin
                      cvs.brush.style:=bsSolid;
                      cvs.brush.color:=couleur(col);
                      cvs.ellipse(x1-s_circle,y1-s_circle,x1+s_circle,y1+s_circle);
                      cvs.brush.style:=bsClear;
                      end
                   ELSE
                       begin
                       {on rcupre les dimensions du rectangle de texte}
                       wwt:=cvs.TextWidth(nam);
                       hht:=cvs.TextHeight(nam);
                       cvs.brush.style:=bsSolid;
                       cvs.brush.color:=clWhite;
                       cvs.rectangle(x1,y1 , wwt + x1,hht + y1);
                       cvs.brush.style:=bsClear;
                       cvs.TEXTout(x1,y1,nam);
                       end;

                       IF deb<>0 then
                          begin
                          IF rer<>0 then cvs.pen.width:=2;
                          cvs.moveto(lx,ly);
                          cvs.lineto(x1,y1);
                          cvs.pen.width:=1;
                          end;
                       deb:= 1;
                       lx:=x+Stations[a].x * (w - (200 * w) div 640) div dx + (50 * w) div 640 - x_min * (w - (200 * w) div 640) div dx;
                       ly:=y+Stations[a].y * (h - (200 * h) div 400) div dy + (100 * h) div 400 - y_min * (h - (200 * h) div 400) div dy;
                       if (written[a]=false)  then
                          begin
                          written[a]:=true;
                          IF (j= 1) OR (j = li[i,0]) then
                             begin
                             //cvs.font.style:=[fsBold];
                             cvs.TEXTout(lx+wwt,ly,' '+Stations[a].nom);
                             cvs.font.style:=[];
                             end
                             ELSE if nom=true then
                                  cvs.TEXTout(lx,ly,' '+Stations[a].nom);
                   end;
               end;  {NEXT j}
          end;

          procedure DessinePlan(x,y,w,h:longint; cvs:TCanvas);
          var ii,a,i,col:integer;
              written:array[0..314] of boolean; {pour noter les noms de stations dj crits}
              x1,y1,x2,y2,dx,dy:integer;
          begin
               col:=0;
               for i:=0 to 314 do written[i]:=false;
               a:= 20;
               FOR ii:= 1 TO a do
                   begin
                        case ii of
                             1..7: i:= ii - 1;
                             8: {7}
                                begin
                                i:= 7;
                                ligne(i,col,x,y,w,h,cvs,written);
                                i:= 8;
                                end;
                             9: {7b}
                                begin
                                i:= 9;
                                ligne(i,col,x,y,w,h,cvs,written);
                                i:= 10;
                                end;
                             10..11:   {8,9}
                                i:= ii + 1;
                             12:   {ligne 10}
                                begin
                                i:= 13;
                                ligne(i,col,x,y,w,h,cvs,written);
                                i:= 14;
                                end;
                             13..14:   {lignes 11 & 12}
                                i:= ii + 2;
                             15:      {ligne 13}
                                begin
                                i:= 17;      {13}
                                ligne(i,col,x,y,w,h,cvs,written);
                                i:= 18;      {13b}
                                end;
                             16..20: {rer}
                                i:= ii + 3;
                        end;
                        ligne(i,col,x,y,w,h,cvs,written);
                        INC(col);
                        IF col = 16 THEN col:= 0;
                   end;

                   if iti then   //ajoute l'itinraire
                      begin
                      dx:= x_max - x_min;
                      dy:= y_max - y_min;
                      cvs.pen.width:=3;
                      cvs.brush.style:=bsSolid;
                      cvs.brush.color:=clRed;
                      for i:=1 to count do
                          begin
                          x1:=Stations[tab[i]].x;
                          y1:=Stations[tab[i]].y;
                          x1:= x+x1* (w - (200 * w) div 640) div dx + (50 * w) div 640 - x_min * (w - (200 * w) div 640) div dx;
                          y1:= y+y1* (h - (200 * h) div 400) div dy + (100 * h) div 400 - y_min * (h - (200 * h) div 400) div dy;
                          cvs.pen.color:=clRed;
                          if i<count then
                             begin
                             x2:=Stations[tab[i+1]].x;
                             y2:=Stations[tab[i+1]].y;
                             x2:= x+x2* (w - (200 * w) div 640) div dx + (50 * w) div 640 - x_min * (w - (200 * w) div 640) div dx;
                             y2:= y+y2* (h - (200 * h) div 400) div dy + (100 * h) div 400 - y_min * (h - (200 * h) div 400) div dy;
                             cvs.moveto(x1,y1);
                             cvs.lineto(x2,y2);
                             end;
                          cvs.pen.color:=clBlack;
                          cvs.Ellipse(x1-6,y1-6,x1+6,y1+6);
                          end;
                      cvs.pen.width:=1;
                      cvs.brush.style:=bsClear;
                      end;

               end;

begin
     if iti then DecodeListe;
     with Form1 do
          begin
          Image.Canvas.Brush.Color:=RGB(200,255,255);
          Image.Canvas.FillRect(Rect(0,0,Image.Width,Image.Height));
          Image.Canvas.brush.style:=bsClear;
          DessinePlan(-50,-250,round(Image.Width*1.15),round(Image.Height*1.8),Image.Canvas);
          first:=false;
          end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i    : integer;
begin
Screen.Cursor:=crHourGlass;
max_chgt:=strToInt(edit1.text) ;
ListBox1.Clear;
ListBox1.Refresh;
ListBox2.Clear;
ListBox2.Refresh;
for i:=0 to nb_Arcs-1 do
    Arcs[i].parcouru:=false ;
min_stations:=50 ;  // initialis  "plus l'infini" : on suppose qu'on ne prendra pas
                    // plus de 50 stations
remplir_partantes ;
trouver(ComboBox1.ItemIndex,  // station dpart ; commence  zro  cause de la tstringlist
        ComboBox2.ItemIndex,  // station arrive ; idem
        0,  // stations parcourues
        -1,  // changements effectus
        '', // station prcdente
        IntToStr(ComboBox1.ItemIndex)) ;  // chemin parcouru ; doit tre identique  la station dpart

Screen.Cursor:=crDefault;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     chemin:=ExtractFilePath(Application.ExeName); {le chemin de l'appli, AVEC l'antislash final}
     SendMessage(ListBox2.handle,LB_SetHorizontalExtent,10*listbox2.width,LongInt(0));
     init_arcs ;
     Cadrage;
     Dessine(false);
     ComboBox1Change(self);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     ListBox1.Height:=(ClientHeight-ListBox1.Top)div 2;
     ListBox2.Top:=ListBox1.Top+ListBox1.Height+4;
     ListBox2.Height:=ClientHeight-ListBox2.Top-8;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
     ListBox2.ItemIndex:=ListBox1.ItemIndex;
     Dessine(true);
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
     ListBox1.ItemIndex:=ListBox2.ItemIndex;
     Dessine(true);
end;

function IsRER(s:integer):boolean;
var l,i:integer;
    rer:boolean;
begin
rer:=false;
    FOR l:= 19 TO 23 do begin
      FOR i:= 0 TO li[l,0] - 1 do
        IF li[l,i + 1] = s then
        begin
          rer:=true;
          break;
        end;
      if rer then break;
    end;
result:=rer;
end;

procedure TForm1.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i,wwt,hht:integer;
    xmin,ymin,dx,dy,w,h,x1,y1:longint;
    ok:boolean;
    nam:string;
    rect1,rect2:TRect;
begin
     w:=round(Image.Width*1.15);
     h:=round(Image.Height*1.8);
     xmin:=x_min;
     ymin:=y_min;
     dx:=x_max-xmin;
     dy:=y_max-ymin;
     {cherche la station i de coordonnes voisines de (x,y)}
     ok:=false;
     for i:=0 to nb_stations do begin
         x1:=Stations[i].x;
         y1:=Stations[i].y;
         x1:= -50+x1 * (w - (200 * w) div 640) div dx + (50 * w) div 640 - xmin * (w - (200 * w) div 640) div dx;
         y1:= -250+y1 * (h - (200 * h) div 400) div dy + (100 * h) div 400 - ymin * (h - (200 * h) div 400) div dy;
         if (x>=x1-5) and (x<=x1+5) and (y>=y1-5) and (y<=y1+5) then
         begin
              ok:=true;
              break;
         end;
     end;
     if ok then begin
         {replace ce qu'il y avait  la place de l'ancien rectangle, s'il y en avait un}
         if first then begin
            Rect1.Top:=0; Rect1.Left:=0; Rect1.Right:=ow; Rect1.Bottom:=oh;
            Rect2.Top:=oy; Rect2.Left:=ox; Rect2.Right:=ox+ow; Rect2.Bottom:=oy+oh;
            Image.Canvas.CopyRect(Rect2, Tampon.Canvas, Rect1);
         end;
         {on rcupre les dimensions du rectangle de texte}
         nam:=' '+Stations[i].nom+' ';
         wwt:=Image.Canvas.TextWidth(nam);
         hht:=Image.Canvas.TextHeight(nam);
         {mmorise ce que va craser le rectangle}
         Rect1.Top:=y1; Rect1.Left:=x1; Rect1.Right:=x1+wwt+10; Rect1.Bottom:=y1+hht;
         Rect2.Top:=0; Rect2.Left:=0; Rect2.Right:=wwt+10; Rect2.Bottom:=hht;
         Tampon.Canvas.CopyRect(Rect2, Image.Canvas, Rect1);
         Image.Canvas.Pen.Color:=clBlack;
         Image.Canvas.brush.style:=bsSolid;
         if IsRER(i) then
            Image.Canvas.brush.color:=clLime
         else Image.Canvas.brush.color:=clYellow;
         Image.Canvas.rectangle(x1,y1 , wwt + x1,hht + y1);
         Image.Canvas.brush.style:=bsClear;
         Image.Canvas.Font.Name:='MS Sans Serif';
         Image.Canvas.Font.Size:=8;
         Image.Canvas.TEXTout(x1,y1,nam);
         {mmorise les coordonnes de ce rectangle}
         ox:=x1; oy:=y1; ow:=wwt+10; oh:=hht;
         first:=true;
     end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     Dessine(false);
     DessineStation(ComboBox1.ItemIndex,-50,-250,round(Image.Width*1.15),round(Image.Height*1.8),Image.Canvas);
     DessineStation(ComboBox2.ItemIndex,-50,-250,round(Image.Width*1.15),round(Image.Height*1.8),Image.Canvas);
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
     Dessine(false);
     DessineStation(ComboBox1.ItemIndex,-50,-250,round(Image.Width*1.15),round(Image.Height*1.8),Image.Canvas);
     DessineStation(ComboBox2.ItemIndex,-50,-250,round(Image.Width*1.15),round(Image.Height*1.8),Image.Canvas);
end;

end.
